﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Timers;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace TicTacToe.Fenster
{
    /// <summary>
    /// Interaktionslogik für win_game.xaml
    /// </summary>
    public partial class win_game : Window
    {

        int timerRest = 0;

        int Hardness;

        BitmapImage kreis = new BitmapImage(new Uri(@"/Andere/Kreis.png", UriKind.Relative));
        BitmapImage kreuz = new BitmapImage(new Uri(@"/Andere/Kreuz.png", UriKind.Relative));

        DispatcherTimer dt = new DispatcherTimer();

        private int[,] feld = new int[3,3]; // 0 = kein stein   1 = rot     -1 = grün



        public win_game(int hardness)
        {
            InitializeComponent();
            newGame();

            Hardness = hardness;

            dt.Interval = TimeSpan.FromSeconds(1);
            timerRest = 5;
            prb_state.Value = 5;
            dt.Tick += dt_Tick;
            dt.Start();

       

        }

        private void dt_Tick(object sender, EventArgs e)
        {
            timerRest -= 1;
            prb_state.Value = timerRest;

            if (timerRest == 0)
            {

                gameFinish(-2);

            }

        }

        public void newGame()
        {

            // Wert 0 für alle 9 Felder
            for (int i = 0; i < feld.GetLength(0); i++)
            {

                for (int j = 0; j < feld.GetLength(1); j++)
                {
                    feld[i,j] = 0;
                }

            }
           

        }

        private void lbl_MouseDown(object sender, MouseButtonEventArgs e)
        {
            Label lbl = (Label)sender;
            selectFeld(int.Parse(lbl.Tag.ToString()) / 10, int.Parse(lbl.Tag.ToString()) % 10, int.Parse(lbl.Tag.ToString()));
        }

        public void selectFeld(int reihe, int spalte, int id)
        {
            if (feld[reihe,spalte] == 0)
            {
                feld[reihe, spalte] = -1;
                getImagebyId(id).Source = kreuz;


                dt.Stop();
                timerRest = 5;
                prb_state.Value = 5;
                dt.Start();

                if (gewonnen(feld))
                {
                    gameFinish(1);
                    dt.Stop();
                }
                else if (unebtschieden())
                {
                    gameFinish(0);
                    dt.Stop();
                }
                else
                {
                    computerDran();
                }

            }
        }

        public void computerDran()
        {
            if (Hardness == 1)
            {
                Random rnd = new Random();

                while (true) {

                    int zeile = rnd.Next(0, 3);
                    int spalte = rnd.Next(0, 3);

                    if (feld[zeile,spalte] == 0)
                    {
                        feld[zeile, spalte] = 1;
                        getImagebyId(zeile * 10 + spalte).Source = kreis;
                        break;
                    }

                }


            }
            else
            {
                // Kann der Computer im nächsten Zug gewinnen

                int[,] newFeld = copy();

                for (int i = 0; i < feld.GetLength(0); i++)
                {
                    for (int j = 0; j < feld.GetLength(1); j++)
                    {

                        if (newFeld[i,j] == 0)
                        {
                            newFeld[i, j] = 1;
                            if (gewonnen(newFeld))
                            {

                                feld[i, j] = 1;
                                getImagebyId(i * 10 + j).Source = kreis;
                                goto finish;

                            } else
                            {
                                newFeld = copy();
                            }
                        }

                    }

                }

                // Kann der Gegner im nächsten Zug gewinnen

                newFeld = copy();

                for (int i = 0; i < feld.GetLength(0); i++)
                {

                    for (int j = 0; j < feld.GetLength(1); j++)
                    {
                        

                        if (newFeld[i, j] == 0)
                        {
                            newFeld[i, j] = -1;
                            if (gewonnen(newFeld))
                            {

                                feld[i, j] = 1;
                                getImagebyId(i * 10 + j).Source = kreis;

                                goto finish;
                            }
                            else
                            {
                                newFeld = copy();
                            }
                        }

                    }

                }

                // Setze in die Mitte

                if (feld[1, 1] == 0)
                {
                    feld[1, 1] = 1;
                
                    getImagebyId(11).Source = kreis;
                    goto finish;
                }


                // Setze random

                while (true)
                {
                    Random rnd = new Random();

                    int zeile = rnd.Next(0, 3);
                    int spalte = rnd.Next(0, 3);

                    if (feld[zeile, spalte] == 0)
                    {
                        feld[zeile, spalte] = 1;
                        getImagebyId(zeile * 10 + spalte).Source = kreis;
                        break;
                    }

                }

            }


        finish:

            if (gewonnen(feld))
            {
                gameFinish(-1);
                dt.Stop();

            }
            else if (unebtschieden())
            {
                gameFinish(0);
                dt.Stop();
            }
            
        }


        public Image getImagebyId(int tag)
        {
            if (int.Parse(img1.Tag.ToString()) == tag)
            {
                return img1;
            } else if (int.Parse(img2.Tag.ToString()) == tag)
            {
                return img2;
            }
            else if (int.Parse(img3.Tag.ToString()) == tag)
            {
                return img3;
            }
            else if (int.Parse(img4.Tag.ToString()) == tag)
            {
                return img4;
            }
            else if (int.Parse(img5.Tag.ToString()) == tag)
            {
                return img5;
            }
            else if (int.Parse(img6.Tag.ToString()) == tag)
            {
                return img6;
            }
            else if (int.Parse(img7.Tag.ToString()) == tag)
            {
                return img7;
            }
            else if (int.Parse(img8.Tag.ToString()) == tag)
            {
                return img8;
            }
            else if (int.Parse(img9.Tag.ToString()) == tag)
            {
                return img9;
            }

            return null;
        }
        

        private bool gewonnen(int[,] testfeld)
        {

            for (int i = 0; i < 3; i++)
            {
                if (Math.Abs(testfeld[i, 0] + testfeld[i, 1] + testfeld[i, 2]) == 3) return true;
                if (Math.Abs(testfeld[0, i] + testfeld[1, i] + testfeld[2, i]) == 3) return true;
            }

            if (Math.Abs(testfeld[0, 0] + testfeld[1, 1] + testfeld[2, 2]) == 3) return true;
            if (Math.Abs(testfeld[2, 0] + testfeld[1, 1] + testfeld[0, 2]) == 3) return true;

            return false;
        }

        public bool unebtschieden()
        {

            for (int i = 0; i < feld.GetLength(0); i++)
            {

                for (int j = 0; j < feld.GetLength(1); j++)
                {
                    if (feld[i,j] == 0)
                    {
                        return false;
                    }
                }

            }

            return true;
        }



        // Array kopieren

        public int[,] copy()
        {
            int[,] newArray = new int[3, 3];

            for (int i = 0; i < feld.GetLength(0); i++)
            {

                for (int j = 0; j < feld.GetLength(1); j++)
                {
                    newArray[i, j] = feld[i,j];
                }

            }

            return newArray;

        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Close();
        }

        public void gameFinish(int state)
        {

            win_gameOver GameFinish;

            if (state == 1)
            {
                GameFinish = new win_gameOver(Hardness, this, "Du hast gewonnen!");
            }else if (state == 0)
            {
                GameFinish = new win_gameOver(Hardness, this, "Unentschieden");
            }
            else if (state == -1)
            {
                GameFinish = new win_gameOver(Hardness, this, "Du hast verloren!");
            }
            else
            {
                GameFinish = new win_gameOver(Hardness, this, "Die Zeit ist abgelaufen");
            }

            GameFinish.Show();
        }
    }
}
